/* George Francis, Chris Hartman*/
/* Mathematics Departments and NCSA */
/* (C) 1993 Board of Trustees Unversity of Illinois */
/* e-mail  gfrancis@math.uiuc.edu */
/* descendant of tnq.c, knotbox.c, moebius.c, cubevert.c, snail.c  */
/* gkf and cmh modification since 4 jun 93 */
/* cmh, ggc, gkf 15 jun 93 */ 
/* gkf 19,20 jun fix mysiz, messages etc */
/* 27 fix generators and other stuff */ 
#include <stdio.h>
#include <stdlib.h>
#include <OpenGL/gl.h>		// Header File For The OpenGL32 Library
#include <OpenGL/glu.h>		// Header File For The GLu32 Library
#include <GLUT/glut.h>		// Header File For The GLut Library
//#include <device.h>
#include <math.h>
#include <sys/time.h>
#include <gl/get.h>
#include <gl/addrs.h>
#include <gl/cg2vme.h>
#include "i2o.c"

/* #define  STEREOGRAPHICS /* enables stereographics switches */
#define  MAX(x,y)       (((x)<(y))?(y):(x))
#define  MIN(x,y)       (((x)<(y))?(x):(y))
#define  ABS(x)         (((x)<0)?-(x):(x))
#define  SGN(x)         ((x)<0?-1:(x)>0?1:0)
#define  SPLIT(x)       (x)>>16, ((x)&0xff00)>>8,(x)&0xff
#define  FOR(a,b,c)     for(a=b;a<c;a++) 
#define  IF(K)          if(getbutton(K))  
#define  SOAK(K)        while(getbutton(K))
#define  TOG_LE(K,f,b)  IF(K){f ^= b; SOAK(K);} 
#define  TOGGLE(K,f,b)  IF(K){f ^= b;} 
#define  IFSHIFT(Y,N)   if(getbutton(LEFTSHIFTKEY)||getbutton(RIGHTSHIFTKEY))\
                            {Y;}else{N;} 
#define  IFALT(Y,N)if(getbutton(LEFTALTKEY)||getbutton(RIGHTALTKEY)){Y;}else{N;}
#define  VERNIER(K,var,amt) \
           {if(claws&K) var += (claws&SHF?-1:1)*amt/(claws&ALT?10:1)/frte;}
#define  VERNIE2(K,var,amt) \
           {float t=1; IFSHIFT(t=-1,) IFALT(t/=10,) IF(K) var+=t*amt;}
#define  PRESS(K,A,b)   IF(K){IFSHIFT(A,b)}
#define  PRES_S(K,A,b)  IF(K){IFSHIFT(A,b) SOAK(K);}
#define  PRES_A(K,A,b)  IF(K){IFSHIFT(A,b) SOAK(K); all=1;}
#define  PRESSA(K,A,b)  IF(K){IFSHIFT(A,b) all=1;}
#define  CYCLER(K,f,m)  PRES_S(K, f=((f-1+m)%m), f=((f+1)%m) )
#define  AT(x,y)        cmov2((x),(y)); charstr(phrase);
#define  LABEL(x,y,W,u) sprintf(phrase,W,u); AT(x,y)
#define  LABEL2(x,y,W,u,v) sprintf(phrase,W,u,v); AT(x,y)
#define  GETS(www,vvv)  {int inx; for(inx=0;inx<3; inx++) www[inx] = vvv[inx];}
#define  DOT(aa,bb)     (aa[0]*bb[0]+aa[1]*bb[1]+aa[2]*bb[2])
#define  NRM(aa)        fsqrt(DOT(aa,aa)) 
#define  LIRP(i,a,b,n)  (a + i*(b-a)/n ) /* from a to b in n steps  */
#define  DG             (M_PI/180.)
#define  CNCP           32   /*# of points around cone    - coarse*/
#define  FNCP           64   /*# of points around cone    - fine*/
#define  CNLP           16   /*# of levels on cone        - coarse*/
#define  FNLP           32   /*# of levels on cone        - fine*/
#define  CNLAT          32   /*# of latitudes on spheres  - coarse*/
#define  FNLAT          64   /*# of latitudes on spheres  - fine*/
#define  CNLON          32   /*# of longitudes on spheres - coarse*/
#define  FNLON          64   /*# of longitudes on spheres - fine*/
#define  PS		.5    /* planesize */
/* claws bit symbols: */
#define  SHF            1    /* shiftkey is down */
#define  ALT            2    /* altkey    "   "  */
#define  P2             4    /* PAD2 key is down */
#define  PPL            8    /* PAD+ key is down */
#define  P4             16   /* PAD4 key is down */
#define  P5             32   /* PAD5 key is down */
#define  P6             64   /* PAD6 key is down */
#define  PMI            128  /* PAD- key is down */
#define  P8             256  /* PAD8 key is down */
#define  HK             512  /* HKEY     is down */
#define  KK             1024 /* KKEY     is down */
#define  UPK            2048 /* UPKEY    is down */
#define  DNK            0x1000 /* DNKEY    is down */
#define  RTK            0x2000 /* RTKEY    is down */
#define  LTK            0x4000 /* LTKEY    is down */
#define  JK             0x8000 /* JKEY    is down */
/* flags  bit symbols: */
#define  FLY            1   /* bit flags, flying mode */ 
#define  CONE           2   /* cone is drawn */
#define  DOUBLECONE     4   /* second cone is drawn */
#define  PLANE          8   /* plane is drawn */
#define  VIRG          16   /* virgu/e is drawn */
#define  CURVE          32
#define  WIRE           64
#define  BEAD           128
#define  STARS          256
#define  SPHERE         512
#define  ALTITU        1024
#define  GENERATOR     2048

int grnd,cube,thick,binoc,win,msg,brt, vuhi, vuhorz, fine,
    curvecolor,conecolor,plancol[4],beadcol[4],wirecolor,gencolor,focsegcolor;
float lux[3]={1.,2.,3.}, lu[3], id[4][4], aff[4][4], amb,pwr,
    lmb, bklt, eps, delta, phi, planex, planey, alpha, beta,
    maus,nose,mysiz,focal,speed,far,kappa,height,alt0,alt1,psize,
    coneP[FNCP+1][3],coneN[FNCP+1][3], sphereP[FNLAT+1][FNLON+1][3];

float aff0[4][4]= {{ 0.9906,  0.1259,  -0.0519,  0.0000 },  
                  {-0.1118,  0.5350,  -0.8375,  0.0000 }, 
                  {-0.0777,  0.8354,   0.5441,  0.0000 }, 
                  { 0.0000,  0.0000,  -2.2000,  1.0000 }}; 

float speeds[4]={ 0.007, 0.022, 0.07, 0.22};

char phrase[256],comment[256];
long znear,zfar,mx,my,xorig,yorig,xcen,ycen;

/*Hartman Movies need */
int wri=0, rea=0, all=0, now=0, fcnt=0, frte=1, fnum=0, clinefrte=1;
int dx, odx=0, dy, ody=0, paws=0, opaws=0; /* mouse condition */
int oclaws=0,claws, oflags=0, flags; /* keyflags */ 

float speedometer(){ /* reports every 8 frames the rate of frames per second */
     double dbl; static double rate; static int ii=0;
     static struct timezone notused; static struct timeval now, then;

     if( ++ii % 8 == 0){  /* 8 times around measure time */
          gettimeofday (&now, &notused); /* elapsed time */
          dbl =  (double)(now.tv_sec - then.tv_sec)
                +(double)(now.tv_usec - then.tv_usec)/1000000 ;
          then = now;  rate = 8/dbl; }
     return((float)rate);
}

deFaults(){int ii,jj; /* in the key of Z */
   flags=WIRE+DOUBLECONE+PLANE+CURVE+BEAD+STARS;
   kappa=1.7; height= 1;      /* cone parameters */
   delta = 0.4; phi = 35;     /* plane parameters*/ 
   planex=-0.4; planey=-0.;
   alt0=1; alt1 = -1; eps = .0007; /* beads parameters*/ 
   cube=0; win=2; msg=1; thick=2; fine =0; 
   maus=.005; speed = speeds[2]; 
   mysiz= 0.02 , focal=1.5, far=20; binoc=0;
   vuhi = -17; vuhorz = 1;   /* -34 for console */ 
   grnd = 0; brt = 255; amb= .25; pwr= 16.; nose=.06; bklt=1.;
   plancol[0] = 0x00dd88; plancol[1] = 0x88dd00; 
   plancol[2] = 0x88dd00; plancol[3] = 0x00dd88; 
   curvecolor = 0x0000ff; wirecolor  = 0x11ffdd;
   beadcol[0] = 0xff1111; beadcol[1] = 0xaaaa11;
   beadcol[2] = 0xff8888; beadcol[3] = 0xffff88;
   conecolor  = 0x551188;
   gencolor = 0x33aaff; focsegcolor = 0xaa33ff;
   psize = PS;

   FOR(ii,0,4)FOR(jj,0,4) aff[ii][jj] = aff0[ii][jj];
   znear= 0x780000; zfar = 0x7f0000;
   conscone();
   conssphere();
}

DeFaults(){
deFaults();  /*Now add any changes*/
#ifdef STEREOGRAPHICS
    plancol[0] = 0x000088; plancol[1] = 0x880000;
    plancol[2] = 0x000088; plancol[3] = 0x880000;
    curvecolor = 0x0000ff; wirecolor = 0xdd0011;
    beadcol[0] = 0x1100ff; beadcol[1] = 0x1100aa;
    beadcol[2] = 0x5500ff; beadcol[3] = 0x8800ff;
    conecolor = 0x880055;
#endif
}

long atox( str ) /* Loren Evans ? or Chris Hartman */
char *str;
{
    long num = 0;
    int radix = 10;
    int val = 0;
    if ( str[0] == '0' && tolower(str[1]) == 'x' )  {
        radix = 16;
        str += 2;
    }
    while ( *str )  {
        if ( !isxdigit(*str) )  return 0;
        switch( tolower(*str) )  {
            case 'a':  val = 10; break;
            case 'b':  val = 11; break;
            case 'c':  val = 12; break;
            case 'd':  val = 13; break;
            case 'e':  val = 14; break;
            case 'f':  val = 15; break;
            default :  val = ( *str - '0' );
        }
        num = num*radix + val;
        str++;
    }
    return num;
}

arguments(argc,argv) int argc; char **argv; /* Pat Hanrahan, 1989 */
     {while(--argc){ ++argv; if(argv[0][0]=='-') switch( argv[0][1]){
     case 'w': win  = atoi(argv[1]); argv++;argc--;break; 
     case 't': thick = atoi(argv[1]); argv++;argc--;break; 
     case 'c': conecolor = atox(argv[1]); argv++;argc--;break; 
     case 'v': curvecolor = atox(argv[1]); argv++;argc--;break; 
     case 'f': wirecolor = atox(argv[1]); argv++;argc--;break; 
     case 'b': beadcol[0] = atox(argv[1]); 
               beadcol[1] = atox(argv[2]);
               beadcol[2] = atox(argv[3]);
               beadcol[3] = atox(argv[4]);
               argv += 4;argc -= 4;break; 
     case 'p': plancol[0] = atox(argv[1]); 
               plancol[1] = atox(argv[2]);
               plancol[2] = atox(argv[3]);
               plancol[3] = atox(argv[4]);
               argv += 4;argc -= 4;break;
     case 'u': lux[0] = atof(argv[1]);   
               lux[1] = atof(argv[2]);  
               lux[2] = atof(argv[3]); 
               argv += 3;argc -= 3;break; 
     case 'm': clinefrte = frte = atoi(argv[1]); argv++;argc--;break; 
     case 's': psize = atof(argv[1]); argv++;argc--;break;
}}} /* to add commandline arguments ad libitum  mimic the syntax */


drawcurve()
{
   int ii,ncp;
   float theta,rad,pt[3];
   ncp=fine?FNCP:CNCP;
   linewidth(2*thick);
   cpack(curvecolor);
   bgnclosedline();
   FOR(ii,0,ncp)
       {
       theta = M_PI*2*ii/ncp;
       rad = delta/(fcos(theta)*fsin(phi*DG)+kappa*fcos(phi*DG));
       pt[0] = rad * fcos(theta);
       pt[1] = rad * fsin(theta);
       pt[2] = rad * kappa;
       v3f(pt);
       }
   endclosedline();
}

drawcircle(float alt,float rad)
{
   int ii,ncp;
   float theta,pt[3];
   ncp=fine?FNCP:CNCP;
   bgnclosedline();
   FOR(ii,0,ncp)
       {
       theta = M_PI*2*ii/ncp;
       pt[0] = rad * fcos(theta);
       pt[1] = rad * fsin(theta);
       pt[2] = alt; 
       v3f(pt);
       }
   endclosedline();
}

conscone()
{
float theta,radius,tmp;
int ii,inx,ncp;

ncp=fine?FNCP:CNCP;
radius = height/kappa; 
/* wrong place for this, put it into drawcone */
/* good luck doing that!  this gets called from many places where drawcone
cannot be called.  Also, drawwire() needs this procedure also, are you going
to put another copy in there?  Besides, it isn't really the wrong place for
this, it is a perfectly good procedure.  It does what the name says.  If you
put it in drawcone, then drawcone does more than draw the cone! */
FOR(ii,0,ncp+1)
    {
    theta = M_PI*2*ii/ncp;

    coneP[ii][0] = radius * fcos(theta);
    coneP[ii][1] = radius * fsin(theta);
    coneP[ii][2] = radius * kappa ;

    coneN[ii][0] = coneP[ii][0];
    coneN[ii][1] = coneP[ii][1];
    coneN[ii][2] = -radius/kappa;
    tmp = NRM(coneN[ii]); FOR(inx,0,3) coneN[ii][inx] /= tmp;
    }
}

drawcone()
{
int inx, ii,jj, nlp,ncp;
float tmp,tpt[3];

nlp=fine?FNLP:CNLP;
ncp=fine?FNCP:CNCP;
FOR(jj,1,nlp)
    {
    bgntmesh();
    FOR(ii,0,ncp+1)
        {
        lmb = DOT(lu,coneN[ii]);if(lmb<0)lmb= -lmb*bklt;
        cpack(dolight(SPLIT(conecolor)));
        GETS(tpt,coneP[ii]); FOR(inx,0,3) tpt[inx]*=(float)jj/nlp; v3f(tpt);
        GETS(tpt,coneP[ii]); FOR(inx,0,3) tpt[inx]*=(float)(jj+1)/nlp; v3f(tpt);        }
     endtmesh();
     }
}

drawwire()
{
int inx, ii,jj, nlp,ncp;
float tmp,tpt[3];

nlp=fine?FNLP:CNLP;
ncp=fine?FNCP:CNCP;
linewidth(thick);
FOR(jj,1,nlp+1)
    {
    bgnline();
    FOR(ii,0,ncp+1)
        {
        lmb = DOT(lu,coneN[ii]);if(lmb<0)lmb= -lmb*bklt;
        cpack(dolight(SPLIT(wirecolor)));
        GETS(tpt,coneP[ii]); FOR(inx,0,3) tpt[inx]*=(float)jj/nlp; v3f(tpt);
        }
    endline();
    }
FOR(ii,0,ncp)
    {
    bgnline();
    FOR(jj,1,nlp+1)
        {
        lmb = DOT(lu,coneN[ii]);if(lmb<0)lmb= -lmb*bklt;
        cpack(dolight(SPLIT(wirecolor)));
        GETS(tpt,coneP[ii]); FOR(inx,0,3) tpt[inx]*=(float)jj/nlp; v3f(tpt);
        }
    endline();
    }
}


conssphere()
{
int ii,jj, nlat,nlon;
float theta,tau;

nlat=fine?FNLAT:CNLAT;
nlon=fine?FNLON:CNLON;
FOR(jj,0,nlat+1)
    {
    tau = DG*(-80 + jj*160/nlat);
    FOR(ii,0,nlon+1)
        {
        theta = M_PI*2*ii/nlon;
        sphereP[jj][ii][0] = fcos(tau) * fcos(theta);
        sphereP[jj][ii][1] = fcos(tau) * fsin(theta);
        sphereP[jj][ii][2] = fsin(tau);
        }
    }
}


drawsphere(float alt0,float rad, int mode, int colr)
/* mode(wire)=0, mode(skin)=1 */
{
int inx, ii,jj, nlat,nlon;
float theta,tau;

nlat=fine?FNLAT:CNLAT; 
nlon=fine?FNLON:CNLON;

pushmatrix(); translate(0,0,alt0);
scale(rad,rad,rad);

FOR(jj,0,nlat)
    {
    if(mode)bgntmesh(); else bgnline();
    FOR(ii,0,nlon+1)
        {
        lmb = DOT(lu,sphereP[jj][ii]);  if(lmb<.0)lmb= -lmb*bklt;
        cpack(dolight(SPLIT(beadcol[colr])));
        v3f(sphereP[jj][ii]);
        if(!mode){endline(); bgnline();}
        lmb = DOT(lu,sphereP[jj+1][ii]);if(lmb<.0)lmb= -lmb*bklt;
        cpack(dolight(SPLIT(beadcol[colr])));
        v3f(sphereP[jj+1][ii]);
        }
    if(mode)endtmesh(); else endline();
    }
popmatrix();
}

dolight(int bb, int gg, int rr)
{
float spec;

    lmb = MAX(amb,lmb);
    spec=brt*( 1. - pwr + pwr*lmb);
    rr = MAX(lmb*rr, spec);
    gg = MAX(lmb*gg, spec);
    bb = MAX(lmb*bb, spec);
    return( (bb<<16) + (gg<<8)+rr);
}

/* Idaszak-Hartman paintor*/
int Hlight(int dog,int cat)
{ return(dolight(dog,abs(cat-128)+64,brt-cat)); }

drawcube(){ int ii,jj ; /* Steve Kommrusch, 1984, uses Gray code */ 
    static int firstime=1; static float vq[8][3];  
    static int fr[]= {0,1,5,1,3,7,3,2,6,2,0,4,5,7,6,4}; 
    if(firstime){ FOR(ii,0,8)FOR(jj,0,3)vq[ii][jj]=(ii&(1<<jj))?PS:-PS;
            firstime=0;}
    lRGBrange(99,0,99,255,0,255,znear,zfar); 
    linewidth(thick); 
    depthcue(1);
    bgnline(); FOR(ii,0,16)v3f(vq[fr[ii]]); endline();
    depthcue(0);
}

drawstars(){ int ii,jj; float tmp[4][4]; /* Glenn Chappell, 1991 */ 
   static int firstime=1; static float stars[1000][4];
   if(firstime){srandom(1);  
           FOR(ii,0,1000) FOR(jj,0,4) 
           stars[ii][jj] = random()/(float)0x40000000-1.0;
           firstime = 0;}
   pushmatrix(); pushmatrix(); /* 2 copies of the projector */
   loadmatrix(aff); getmatrix(tmp);
   tmp[3][0]=tmp[3][1]=tmp[3][2]=0; /*pure rotation */
   popmatrix(); multmatrix(tmp);
   cpack(0xffffff); zclear();
   bgnpoint(); FOR(ii,0,1000)v3f(stars[ii]); endpoint();
   popmatrix(); zclear(); /* the way it was before */ 
}

drawvec()
{
float pt[3]={0,0,0};

    linewidth(2*thick);
    cpack(0xffffaa);
    pushmatrix();
    rot(phi, 'y');
    bgnline(); v3f(pt); pt[2] = delta; v3f(pt); endline();
    popmatrix();
}

drawplane()
{
float planevt[4][3] = {{-1.,-1., 0.},
                       { 1.,-1., 0.},
                       { 1., 1., 0.},
                       {-1., 1., 0.}};
int inx;

    pushmatrix();
    rot(phi, 'y');
    translate(planex,planey,delta);
    scale(psize,psize,psize);
    bgnpolygon();
    FOR(inx,0,5){cpack(plancol[inx%4]); v3f(planevt[inx%4]);} 
    endpolygon();
    popmatrix();
}

drawgen() 
{
float pt[3], ptC[3], ptH[3],sincon,coscon,sinphi,cosphi, rad ;

/* calculate particulars */
   sinphi = fsin(phi*DG); 
   cosphi = fcos(phi*DG);
   sincon = 1/fsqrt( 1. + kappa*kappa);
   coscon = kappa*sincon;

   linewidth(2*thick);
/* top tangency circle */  
   cpack(beadcol[2]);
   drawcircle(alt0*coscon*coscon, alt0*coscon*sincon);
/* bottom tangency  circle */ 
   cpack(beadcol[3]);
   drawcircle(alt1*coscon*coscon, alt1*coscon*sincon);

   cpack(gencolor);
   bgnline(); /* Generator */
   pt[0] = fcos(alpha)*height/kappa;
   pt[1] = fsin(alpha)*height/kappa;
   pt[2] = height; 
   v3f(pt);
   pt[0] *= -1;
   pt[1] *= -1;
   pt[2] *= -1;
   v3f(pt);
   endline();

   cpack(focsegcolor);
   bgnline(); /* Focus-to-curve segments */
/* Top focus */
   pt[0] = -alt0*sinphi*sincon;
   pt[1] = 0; 
   pt[2] = alt0*(1. - cosphi*sincon);
   v3f(pt);
/* curve point */
   rad = delta/(fcos(alpha)*sinphi + kappa*cosphi);
   pt[0] = rad * fcos(alpha);
   pt[1] = rad * fsin(alpha);
   pt[2] = rad * kappa;
   v3f(pt);
/* bot focus */
   pt[0] = alt1*sinphi*sincon;
   pt[1] = 0;
   pt[2] = alt1*(1. + cosphi*sincon);
   v3f(pt);
   endline();

return;
}

drawall(float nose)
{  float sincone;  /* kappa=cot_cone_angle */
   sincone = 1/fsqrt(1. + kappa*kappa);

   if(flags&ALTITU||flags&GENERATOR){
   alt0 =  delta/(fcos(phi*DG) - sincone); 
   alt1 =  delta/(fcos(phi*DG) + sincone); 
   }
   if(flags&STARS)drawstars();
   translate(-nose,0,0); multmatrix(aff); rot(beta,'z');
   if(cube)drawcube();
   lsetdepth(100,0x7fffff);
   if(flags&CONE) 
       {
       drawcone();
       if(flags&DOUBLECONE)
           {
           scale(-1,-1,-1);
           drawcone();
           scale(-1,-1,-1);
           }
       }
   if(flags&PLANE) drawplane();
   if(flags&VIRG)   drawvec();
   if(flags&BEAD)
       {
       drawsphere(alt0, eps*SGN(alt0) + alt0*sincone, 1, 0);
       drawsphere(alt1, eps*SGN(alt1) + alt1*sincone, 1, 1);
       }

   lsetdepth(0,0x7fffff-100);
   if(flags&SPHERE)
       {
       drawsphere(alt0, alt0*sincone, 0, 2);
       drawsphere(alt1, alt1*sincone, 0, 3);
       }
   if(flags&CURVE) drawcurve();
   if(flags&GENERATOR) drawgen();
   if(flags&WIRE)
       {
       drawwire();
       if(flags&DOUBLECONE)
           {
           scale(-1,-1,-1);
           drawwire();
           scale(-1,-1,-1);
           }
       }
}

messages(){ /* text information as heads-up display */
float horz,vert;
#define LFSPACE 0.035
#define LF (vert-=LFSPACE)
#define LAB_L(s,u) LABEL(horz,vert,(s),(u))
#define LAB_L2(s,u,v) LABEL2(horz,vert,(s),(u),(v))
#define A_T AT(horz,vert)

    zclear();viewport(0,2*mx,0,2*my); ortho2(-(float)mx/my,(float)mx/my,-1,1); 
    if(!binoc){ curson();
                cpack( (flags&FLY)?0x888888:0xff0000 );
                linewidth(3); circ(0.,0.,.02);}
    cpack(grnd?0:0xffffff);
    if(win==0)ortho2(-1.2,0,-1,1);  /* make sure speedometer is visible */
    horz=-1.2; vert=.95;
if(win !=0){   /* suppress messages on voluntary windows */
    LAB_L ("(ESC)ape (Z)ap",0); LF;LF;

    LAB_L ("(C)one (W)ire (D)ouble",0); LF;
    LAB_L2("(K)appa %5.3f (H)eight %5.3f",kappa,height); LF;LF;

    LAB_L  ("(P)lane on PAD keys:",0); LF;
    LAB_L  ("norma(/) phi(5)ve %5.3f",phi); LF;
    LAB_L  ("(+)(-) delta %5.3f",delta); LF;
    LAB_L  ("(8)(6)(4)(2) NEWS",0); LF;LF;

    LAB_L ("(B)ead(S) (A)ltitudes:",0); LF;
    LAB_L ("Blue (UP) %5.3f", alt0); LF;
    LAB_L ("Cyan (DN) %5.3f", alt1); LF;
    LAB_L ("(E)psilon  %g",eps); LF;LF;

    horz=-.6; vert=.95;
    LAB_L("(BAR)fly (V)iew (L)ine (`)stars (Q)ube (PRSCR)(PGDN)(F12)(*)(H/E)",0); LF;LF;

    horz=.75; vert=.95;
    LAB_L2("(F1)amb %g (F2)spec %g", amb, pwr); LF;LF;

    LAB_L ("(N)ose %g",nose); LF;
    LAB_L ("(1-4) speed  %g",speed); LF;
    LAB_L ("near clipper %g", mysiz*focal); LF;
    LAB_L ("f(O)cal factor %g",focal); LF;
    LAB_L ("my s(I)ze %g",mysiz); LF;
    LAB_L ("far clippe(R)= %g",far); LF;LF;

    LAB_L ("vuh(0)rz %d",vuhorz); LF;
    LAB_L ("(+)vuhi  %d",vuhi); LF;LF;
/*  LAB_L2("fnum >%d< fra(M)rate %d",fnum,frte); LF;LF; */
    horz=.4; vert=-.95-LFSPACE;
    LAB_L("  The shifted key inverts the action, usually.",0); LF;LF;
} /* end suppression of messages on voluntary windows */
    horz=-1.2; vert=-.95;
    sprintf(phrase,"%d>%d<%d>%0.1f ",wri+2*rea,fnum,frte,speedometer()); 
    cpack(0x00ffff); A_T; cpack(grnd?0:0xffffff); LF;
if(win !=0){
    LAB_L ("illiConic by George Francis, Chris Hartman, Glenn Chappell, U Illinois, 1993",0); LF;LF;
    cmov2(-1.2,-.9); charstr(comment+1);
} /* end suppression of messages on voluntary windows */
}

keyboard(){ /* control keys */
#ifdef STEREOGRAPHICS
    PRESS(PAGEUPKEY, setstereo(0), setstereo(1))
#endif
    PRESS(EQUALKEY, vuhi--,vuhi++)                            /* for CAVE */
    PRESS(ZEROKEY, vuhorz--,vuhorz++)                        /* for CAVE */
    TOG_LE(PRINTSCREENKEY,msg,1)           /* messages and cursor vanish */
    TOG_LE(PADASTERKEY, grnd,1)                 /* white for the printer */
    PRES_S(VKEY,binoc=(binoc-1+3)%3;vuhi=-17;vuhorz=1,
      binoc=(binoc+1)%3;vuhi=-17;vuhorz=1)            /* Cross your eyes */
    CYCLER(QKEY,cube,2)                            /* stick cube appears */
    PRESS(ZKEY, DeFaults(), deFaults())                   /* zap changes */
    PRESS(RKEY, far *= 1.01 , far   /= 1.01)           /* beware of this */ 
    VERNIE2(F1KEY, amb, .01)                            /* ambient floor */
    VERNIE2(NKEY,  nose,.01)                        /* parallax adjuster */ 
    VERNIE2(EKEY,  eps,.001)                        /* an epsilon       */ 
    PRES_S(TKEY,thick++, thick=(thick==1?1:thick-1)) /* thickness adjuster */ 
    PRES_S(F2KEY, pwr = 1. ,  pwr *= 2. )               /* specular ramp */
    PRES_S(FKEY,fine=0;conscone();conssphere,
      fine=1;conscone();conssphere)      /* coarse/fine */
/* the following inputs are movie recorded */
    PRESSA(IKEY, mysiz /= 1.01, mysiz *= 1.01)      /* rescale the world */ 
    PRESSA(OKEY, focal *= 1.01, focal /= 1.01)              /* telephoto */
    PRES_A(ONEKEY  ,speed=speeds[0],speed=speeds[0];)
    PRES_A(TWOKEY  ,speed=speeds[1],speed=speeds[1];)
    PRES_A(THREEKEY,speed=speeds[2],speed=speeds[2];)
    PRES_A(FOURKEY ,speed=speeds[3],speed=speeds[3];)
    claws = 0; paws=0;
    TOG_LE(SPACEKEY,flags,FLY)                            /* flying mode */ 
    TOG_LE(ACCENTGRAVEKEY, flags,STARS)          /* turn stars on or off */
    TOG_LE(CKEY,flags,CONE)                            /* coneskin drawn */ 
    TOG_LE(WKEY,flags,WIRE)                            /* conewire drawn */ 
    TOG_LE(BKEY,flags,BEAD)                           /* sphere rendered */ 
    TOG_LE(SKEY,flags,SPHERE)                            /* sphere drawn */ 
    TOG_LE(AKEY,flags,ALTITU)                          /* free altitudes */ 
    TOG_LE(PKEY,flags,PLANE)                              /* plane drawn */ 
    TOG_LE(DKEY,flags,DOUBLECONE)                     /* two cones drawn */ 
    TOG_LE(GKEY,flags,GENERATOR)                     /* generator  drawn */ 
    TOG_LE(F5KEY,flags,CURVE)                            /* curve  drawn */ 
    TOG_LE(PADVIRGULEKEY,flags,VIRG)                    /* normal  drawn */ 
    TOGGLE(HKEY,claws,HK)
    TOGGLE(KKEY,claws,KK)
    TOGGLE(PAD2,claws,P2)
    TOGGLE(PADPLUSKEY,claws,PPL)
    TOGGLE(PAD4,claws,P4)
    TOGGLE(PAD5,claws,P5)
    TOGGLE(PAD6,claws,P6)
    TOGGLE(PADMINUS,claws,PMI)
    TOGGLE(PAD8,claws,P8)
    TOGGLE(RIGHTARROWKEY,claws,RTK)
    TOGGLE(LEFTARROWKEY,claws,LTK)
    TOGGLE(UPARROWKEY,claws,UPK)
    TOGGLE(DOWNARROWKEY,claws,DNK)
    TOGGLE(JKEY,claws,JK)

    IFSHIFT(claws |= SHF,);  
    IFALT(claws |= ALT,);
    IF(MOUSE1)paws|=1;
    IF(MOUSE2)paws|=2;
    IF(MOUSE3)paws|=4;

    dx = getvaluator(MOUSEX) - xcen; dx = ABS(dx)>5?dx:0;
    dy = getvaluator(MOUSEY) - ycen; dy = ABS(dy)>5?dy:0;
}

kitchen() { /* act on now-bits whether keyed-in or read-in */
    VERNIER(P2,planex, .05)
    VERNIER(P8,planex,-.05)
    VERNIER(P6,planey, .05)
    VERNIER(P4,planey,-.05)
    VERNIER(PPL,delta,  .05)
    VERNIER(PMI,delta, -.05)
    VERNIER(P5,phi,    5.)
    VERNIER(HK,height, .05)
    VERNIER(KK,kappa , .05)
    if(claws&(HK+KK)) conscone(); /* HK does KK doesnot work with movies */ 
    VERNIER(UPK,alt0,  .05)
    VERNIER(DNK,alt1,  .05)
    VERNIER(RTK,alpha,  .1)
    VERNIER(LTK,alpha, -.1)
    VERNIER(JK,beta, -5.)

    loadmatrix(id);
    if((~flags)&FLY) (aff[3][0],aff[3][1],aff[3][2]);
    rot(-dy*maus/frte, 'x'); rot(dx*maus/frte,'y');

    if(paws&4)if(claws&SHF) rot(-10./frte,'z');else rot (-1./frte, 'z');
    if(paws&1)if(claws&SHF) rot( 10./frte,'z');else rot ( 1./frte, 'z');
    if((~flags)&FLY) translate(-aff[3][0],-aff[3][1],-aff[3][2]);
    if(paws&2) if(claws&SHF)translate(0,0,-speed/frte);
               else translate(0,0,speed/frte);
    multmatrix(aff); getmatrix(aff);
}

testinputs()
{
   if(rea) readline();
   now = ((dx != odx)||(dy != ody)||(paws != opaws)||(claws != oclaws));
   all = all || (flags != oflags) ;  /* save Old Glory too if changed */
   odx = dx ; ody = dy; opaws = paws; oclaws = claws; oflags = flags; 
   if( wri && all){writenow(); writeall();}
   if( wri && now) writenow();
}
#ifdef STEREOGRAPHICS
setstereo(Boolean ster)
{
unsigned char switchbits;

if (ster)
    {
    switchbits = getvideo(CG_MODE) & 0xF0 ;
    setvideo(DE_R1,DER1_G_60HZ|DER1_UNBLANK);
    setvideo(CG_MODE,switchbits|CG2_M_FORMAT | CG2_M_MODE4);
    setmonitor(STR_RECT);  /* this switches to the stereo 120 Hz mode */
    }
else
    {
    setvideo(GL_VIDEO_REG,0x4a);
    setmonitor(1);
    }
}
#endif

readsetup(){int ii,jj,dummy;    /* -3 followed by...*/
   scanf("%d %g %d %d %g %g %g %g %g %g %g %g",&frte,&far,&znear,&zfar,
                &delta,&phi,&alt0,&alt1,&planex,&planey,&kappa,&height);
   /*and then the view matrix: */
   FOR(ii,0,4) FOR(jj,0,4)scanf (" %g  ",&aff[ii][jj]); 
   conscone(); frte *= clinefrte; beta = 0;
   }
readall(){int ignore; /* \n 0 followed by this, fnum is ignored */ 
    scanf("%x %g %g %g %d", &flags,&focal,&mysiz,&speed,&ignore);}
readnow(){ int ignore; /* \n any#>0 followed by this,  fnum is ignored*/ 
      scanf("%d %d %x %x %d", &dx, &dy, &paws, &claws, &ignore); }
readline() {
static wait=0,hdx,hdy,hpaws,hclaws;
   if(wait>0) 
      { dx=hdx; dy=hdy; paws=hpaws; claws=hclaws;}
   else
      {
      readnow();
      hdx = dx; hdy=dy; hpaws=paws; hclaws=claws; /*hold these for use later*/
      if(scanf("%d",&wait)==-1) {rea =0;wait=1;rewind(stdin);}
      while(wait<1)
         {
         switch(wait) 
            {
            case 0  : readall();     break;  /*less frequent variables*/
            case -1 : gets(comment); break;  /*comment*/
            case -2 : rea = 0; wait = 1;rewind(stdin); break; /*movie end*/
            case -3 : readsetup();   break;  /*ALL variables*/
            }
         if(scanf("%d",&wait)==-1) {rea =0;wait=1;rewind(stdin);}
         }
      wait *=frte; /*make things happen frte times as slowly*/
      }
   wait--;
}
writenow(){
   printf("%d %3d %3d %4x %4x %3d \n", fcnt,dx,dy,paws,claws,fnum);
   fcnt = now = 0; }
writeall(){
   printf("0 %x % g % g  %g  %3d\n", flags,focal,mysiz, speed,fnum);
   all=0; }
writesetup(){int ii,jj;
   printf("-3 %d %g %d %d %g %g %g %g %g %g %g %g \n",frte,far,znear,zfar,
                delta,phi,alt0,alt1,planex,planey,kappa,height);
   FOR(ii,0,4){FOR(jj,0,4)printf(" %2.4f  ",aff[ii][jj]); printf("\n");} }

main(argc,argv) int argc; char **argv; {int ii,jj; float tmp; 
    FOR(ii,0,4)FOR(jj,0,4)id[ii][jj]=(ii==jj?1:0);
    DeFaults();
    arguments(argc,argv); /* but use Hanrahan's argumentor */
    tmp=NRM(lux); FOR(ii,0,3) lux[ii] /= tmp; 
    switch( win){
       case 0: break;
       case 1: mx = 320; my=256; prefposition(0,640,0,512); break;
       case 2: mx = 640; my=512; prefposition(0,1280,0,1024); break;
       case 3: mx = 320; my=243; prefposition(0,640,0,486); break;
       }
    /*noborder();*/
    winopen("illiConic");
    zbuffer(1); doublebuffer(); RGBmode(); gconfig();

while(!getbutton(ESCKEY)){  /* eternal loop */

   reshapeviewport(); getorigin(&xcen,&ycen);
   getsize(&mx,&my); mx/=2; my/=2; xcen += mx; ycen += my;

/* Hartman's Movies */
   PRES_S(PAGEDOWNKEY,wri=0,
       fnum=fcnt=wri=1;writenow();writeall();writesetup();fcnt=1;writenow())
/* read if (F12) and not already reading */
    if(getbutton(F12KEY)&&!rea)
       if((ii=scanf("%d",&jj)) != -1)
          {
          SOAK(F12KEY);
          rea=1; fnum=0;
          readline();
          }

   if(wri || rea)fnum++;  /* an attempt to count actual frames */
   fcnt++;  /* advance frame count */
 
   keyboard();       /* get all of the inputs */  
   testinputs();     /* save (if writing) or get (if reading) the inputs */ 
   kitchen();        /* act on all of the inputs*/

   FOR(ii,0,3)
      {lu[ii]=0; FOR(jj,0,3) lu[ii] += aff[ii][jj]*lux[jj];} /*rotate light*/

   cpack(grnd?0xffffff:0); clear(); zclear();

/* right eye uses left viewport */
   if   (binoc==1)  {viewport(0,mx,0.5*my,1.5*my);  tmp=nose;}
   else if(binoc==2){viewport(0,1280,512,1028);tmp=nose; }
   else tmp=0.0;

   window(-mysiz*(float)mx/my,mysiz*(float)mx/my,-mysiz,mysiz,mysiz*focal,far);
   drawall(tmp);

   if(binoc){
      if (binoc==1) {viewport(mx,2*mx,0.5*my,1.5*my); }
        /* left eye is right */
      else {viewport(0+vuhorz,1280+vuhorz,0+vuhi,512+vuhi); }
      window(-mysiz*(float)mx/my,mysiz*(float)mx/my,-mysiz,mysiz,mysiz*focal,far);
      drawall(-tmp);
     }

   cursoff(); if(msg)messages(); 
   swapbuffers(); 

   IF(HOMEKEY) while(!getbutton(ENDKEY));
} /* end while loop */
if(wri) {writenow(); writeall(); writesetup();}

#ifdef STEREOGRAPHICS
setstereo(0);
#endif

} /* end it all */
